﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public SQL1 As SQL
	
	Public SQLDataBasePath As String
	Public SQLDateBaseName As String
	
	Public SQLTabelName As String

	Public ListIDList As List			' list containing the IDs of the Stock table
	Public StuffIDList As List		' list containing the IDs of the Product table
	Public ShopIDList As List		' list containing the IDs of the Supplier	table
	' we need them because the IDs can be different from the list indexes
	' if we delete an entry its ID is lost
	
	Public SelectedListID As Long
	Public SelectedStuffID As Long
	Public SelectedShopID As Long
	
	' we need to know which main button was selected as an operation
	Public SelectedOperation As String
	
	'Variables for Edit
	'the Edit Activities have two modes  "Add"  and "Edit"
	Public ListEditMode As String
	Public StuffEditMode As String
	Public ShopEditMode As String

	'Variables for Filter
	'variable for the filter query,
	'defined in the btnFilter_Click routine of the Filter module
	'and will be used In the DBWebView ShowTable routine
	Public FilterQuery = "" As String
	
	' flag for the filter active or inactive
	Public FilterActive = False As Boolean
	
	' Boolean operator used in the filter
	' can be OR or AND
	Public FilterBooleanOperator = "AND " As String
	
	' Variables used to hold the selected indexes of the Spinners
	Public FilterSelectedStuff As Int
	Public FilterSelectedShop As Int
	Public FilterSelectedDateBegin As Int
	Public FilterSelectedDateEnd As Int
	
	Public GotBarCode As String
	Public GotBarScanType As String

	Public HtmlCSS As String
End Sub

Sub Service_Create
	
	'initialize the variables
	SQLDataBasePath = File.DirDefaultExternal      '.DirRootExternal
	'Log("SQL Data Path" & SQLDataBasePath)
	SQLDateBaseName = "stuff.db"
	
	FilterQuery = ""
	FilterActive = False
	FilterBooleanOperator = "OR "

'	File.Delete(SQLDataBasePath, SQLDateBaseName) ' only for testing, removes the database
		
	'check if the database already exists
	If File.Exists(SQLDataBasePath, SQLDateBaseName) = True Then
		'if yes, invoke it
		SQL1.Initialize(SQLDataBasePath, SQLDateBaseName, True)
	Else
		'if no, initialize it
		SQL1.Initialize(SQLDataBasePath, SQLDateBaseName, True)
		'and create it
		SQLInit
	End If

	HtmlCSS = "table {width: 100%;border: 1px solid #cef;text-align: left; }" _
		& " th { font-weight: bold;	background-color: #acf;	border-bottom: 1px solid #cef; }" _ 
		& "td,th {	padding: 4px 5px; }" _
		& ".odd {background-color: #def; } .odd td {border-bottom: 1px solid #cef; }" _
		& "a { text-decoration:none; color: #000;}"
		
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

'create the List database
Sub SQLInit
	Private query As String
	
	''query = "CREATE TABLE List (Number INTEGER, StuffID INTEGER, shopID INTEGER, Date INTEGER)"
	' insert one new field for cancel off list because its been purchased
	' add three spare fields just so they are there and can be used in future without regenerating the DB
	
	query = "CREATE TABLE List (StuffName TEXT, ShopName TEXT, LastPrice REAL, Date INTEGER, Bought BOOLEAN, Spare1 TEXT, Spare2 TEXT, Spare3 TEXT)"
	SQL1.ExecNonQuery(query)

	'''''''''''''''''''''''''''''''
	' THIS table could hold the frequent stuff flags and autoADD flags
	' which would mean that the Frequent table catered for below is redundant
	' but a lot more programming to do on the Stuff and editStuff modules
	' would then have to be done.
	query = "CREATE TABLE Stuff (barCode TEXT, StuffName TEXT, Price REAL, shopID INTEGER, Freq B00LEAN, AutoADD BOOLEAN)"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Stuff VALUES ('6001021316792', 'Arduino Uno', 13.50, 1, 'true', 'false')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Stuff VALUES ('5014602802219', 'Arduino Nano', 17.50, 3, 'false', 'false')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Stuff VALUES ('barCode', 'Arduino Mega', 25.00, 2, 'false', 'true')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Stuff VALUES ('barCode', 'Arduino Mini', 15.00, 2, 'false', 'true')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Stuff VALUES ('5014602802218', 'ESP8326', 25.99, 1, 'false', 'false')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Stuff VALUES ('60063809', 'ESP 32', 17.55, 4, 'false', 'false')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Stuff VALUES ('9001448071653', 'BPM280', 19.55, 4, 'false', 'false')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Stuff VALUES ('9771810794007', 'BME280', 170.55, 4, 'false', 'false')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Stuff VALUES ('5706238310571', 'nRF24L01', 170.55, 4, 'false', 'false')"
	SQL1.ExecNonQuery(query)
'''''''''''''''''''''''''''''''		
	query = "CREATE TABLE Shop (Name TEXT, Address TEXT, City TEXT)"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Shop VALUES ('Pick-n-Pay','Pepper Grove Mall', 'GRAHAMSTOWN')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Shop VALUES ('Spar', 'African Street', 'GRAHAMSTOWN')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Shop VALUES ('Checkers', 'High Street', 'GRAHAMSTOWN')"
	SQL1.ExecNonQuery(query)
	query = "INSERT INTO Shop VALUES ('Shoprite', 'Beaufort', 'GRAHAMSTOWN')"
	SQL1.ExecNonQuery(query)

End Sub


