﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9
@EndOfDesignText@
    '#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private xui As XUI
	Private SQL2 As SQL
	Private formatter As B4XFormatter
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private ListStuffView1 As CustomListView ' cards

	Private lblTitle As B4XView ' cards
	Private namelblContent As B4XView ' cards
	
	Private card2Panel1 As Panel

	Private todayACColoredButton1 As ACColoredButton
	Private exitListACButton1 As ACButton

	Private lblAction2 As Label ' cards
	Private totstuffLabel1 As Label
	Private priceLabel1 As Label
	Private shopLabel1 As Label
	Private freqLabel1 As Label
	Private autoLabel1 As Label
	Private add2listlblAction1 As Label '  B4XView doesn't change anything
	Private add2listlblAction2 As Label
	Private cardnumberLabel1 As Label

	Private countCARDS As Int
	Private curINDEX  As Int
	
	Private addedACCheckBox1 As ACCheckBox

End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")

	Activity.LoadLayout("liststuff")  ' cards
	
	If FirstTime Then
		formatter.Initialize
		Dim DefaultFormat As B4XFormatData = formatter.GetDefaultFormat
		DefaultFormat.MaximumFractions = 2
		DefaultFormat.MinimumFractions = 2
		DefaultFormat.Prefix = "R"
		Dim NegativeFormat As B4XFormatData = formatter.CopyFormatData(DefaultFormat)
		NegativeFormat.TextColor = xui.Color_Red
		NegativeFormat.Prefix = "R ("
		NegativeFormat.Postfix = ")"
		NegativeFormat.FormatFont = xui.CreateDefaultBoldFont(15)
		formatter.AddFormatData(NegativeFormat, formatter.MIN_VALUE, 0, False)
	End If

	countCARDS = 0
	
	FillCard2
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Private Sub CreateItem(Width As Int, Title As String,  Content As String) As Panel '' Image As String,
	Dim p As B4XView = xui.CreatePanel("")
	Dim height As Int = 280dip

	If GetDeviceLayoutValues.ApproximateScreenSize < 4.5 Then height = 310dip
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	p.LoadLayout("Card2")
	
	lblTitle.Text = Title
	namelblContent.Text = Content
	cardnumberLabel1.Text  = countCARDS
		' Log (" card number -> " & cardnumberLabel1.Text & " Content -> " & Content)
	
	add2listlblAction1.Tag = countCARDS
	add2listlblAction1.Visible = True
	add2listlblAction2.Visible = False

		' Log(" countCARDS -> " & countCARDS & " card number -> " & cardnumberLabel1.Text & " Label tag -> " & add2listlblAction1.Tag )
	
	SetColorStateList(add2listlblAction1, xui.Color_LightGray, add2listlblAction1.TextColor)
	SetColorStateList(add2listlblAction2, xui.Color_LightGray, add2listlblAction2.TextColor)

	Return p
End Sub

Sub SetColorStateList(Btn As Label,Pressed As Int,Enabled As Int)
	Dim States(2,1) As Int
	States(0,0) = 16842919    'Pressed
	States(1,0) = 16842910    'Enabled
	Dim CSL As JavaObject
	CSL.InitializeNewInstance("android.content.res.ColorStateList",Array(States,Array As Int(Pressed, Enabled)))
	Dim B1 As JavaObject = Btn
	B1.RunMethod("setTextColor",Array As Object(CSL))
End Sub

Sub FillCard2
	Dim Cursor1 As Cursor
	Dim dummyStuff As String
	
	SQL2.Initialize(File.DirDefaultExternal, "stuff.db", False)
	
	Dim rs As ResultSet = SQL2.ExecQuery("SELECT Stuff.barCode, Stuff.StuffName, Stuff.Price, Stuff.shopID, Stuff.Freq, Stuff.AutoADD, Shop.Name AS Shop FROM Stuff, Shop WHERE Shop.rowID = Stuff.shopID")
	
	Do While rs.NextRow
		Dim BarCode As String
		Dim ShopName As String
		Dim FormatPrice As String
		Dim junk As String
		Dim freqtest As String
		Dim autotest As String

		countCARDS = countCARDS + 1
		totstuffLabel1.Text = rs.RowCount

		BarCode = rs.GetString("Stuff.barCode")
		dummyStuff =  rs.GetString("Stuff.StuffName")
			'Log ("Stuff Name -> " & dummyStuff & "...")
		
		ListStuffView1.Add(CreateItem(ListStuffView1.AsView.Width, $"${BarCode}"$, dummyStuff), "")
'''		Dim index As Int = (ListStuffView1.GetItemFromView(Sender) + 1)
			' Log($"This is the given index value fot the card being created Index -> ${index}"$)

		add2listlblAction1.Visible = True 	' want this one to be visible
		add2listlblAction2.Visible = False  ' and this one to be invisible

		addedACCheckBox1.Checked = False 
		cardnumberLabel1.Tag     = countCARDS
		
		junk = rs.GetString("Stuff.shopID")  ' what shop name is it

			'Log("shopID -> " & junk & " card number -> " & cardnumberLabel1.Tag & " countCARDS -> " & countCARDS)
		
		Cursor1 = SQL2.ExecQuery("SELECT Shop.Name FROM Shop WHERE Shop.rowID = " & junk)
		Cursor1.Position = 0
		ShopName = Cursor1.GetString2(0)
			' Log ("Shop Name -> " & ShopName)

		shopLabel1.Text = ShopName
			'Log ("BarCode -> " & BarCode & " * Stuff -> " & shopLabel1.Text)
		
		FormatPrice = rs.GetString("Stuff.Price")
		FormatPrice = NumberFormat2 (FormatPrice,1,3,2,False)
			'Log ("Price -> " & FormatPrice)

		priceLabel1.Text = FormatPrice
			'Log ("Formatted Price -> " & priceLabel1.Text)
		
		freqtest = rs.GetString("Stuff.Freq")
		autotest = rs.GetString("Stuff.AutoADD")
		
		Select freqtest
			Case  "true", "True"
				freqLabel1.Text = "Yes"
					'  Log ("freq YES")
			Case "false", "False"
				freqLabel1.Text = "No"
		End Select
		
		Select autotest
			Case  "true", "True"
				autoLabel1.Text = "Yes"
					' Log ("auto YES")
			Case "false", "False"
				autoLabel1.Text = "No"
		End Select

	Loop

	rs.Close

End Sub


Sub add2listlblAction1_Click
	Dim CursorGet As Cursor ', CursorPut

	Dim barTEXT, priceTEXT, shopTEXT, stuffTEXT, Spare1, Spare2, Spare3 As String
	Dim Bought As Boolean
	Dim PutList, GetChoice As String

		' This is the long searched for solution to this : it works at last : silly search as well was in original not comprehended example
	Dim index As Int = (ListStuffView1.GetItemFromView(Sender) + 1) ' this is just the index of each card in the list
	
		Log($"This is the chosen stuff-list item Index -> ${index}"$)

	curINDEX = index ' might need this as a reference to a card at some point
	
		' This means that the index / row to add to the shopping list can be
		' searched and detail collected - based on the query for INSERT into table LIST in the DB
	
	add2listlblAction1.Visible = False  ' when the first card X is clicked then 
										' the LAST card's X is turned off
										' and the Tick is turned on (though no TICK displayed for some reason)
	add2listlblAction2.Visible = True

	GetChoice = "SELECT barCode, StuffName, Price, shopID, Freq, AutoADD FROM Stuff WHERE rowID = " & index  ' Starter.SelectedStuffID

		' get the detail from the database
	CursorGet = SQL2.ExecQuery(GetChoice)
	CursorGet.Position = 0
	
	barTEXT = CursorGet.GetString2(0)
	stuffTEXT = CursorGet.GetString2(1)
	priceTEXT = CursorGet.GetString2(2)
		'Log ("getItem -> " & CursorGet.GetString2(3))
	shopTEXT = (CursorGet.GetString2(3) - 1)
		'Log ("GetItem Text -> " & stuffspnShop.GetItem (CursorGet.GetString2(3) - 1))
		'stuffspnShop.SelectedIndex = CursorGet.GetString2(3)
	Bought = False
	Spare1 = ""
	Spare2 = ""
	Spare3 = ""

		' put the detail into the secondary list
		Log ("INDEX -> " & curINDEX & " Stuff Name ->" & stuffTEXT & " shop name -> " & shopLabel1.Text & " Chosen Price -> " & priceTEXT & " Date -> " & DateTime.Now )

		''query = "CREATE TABLE List (StuffName TEXT, ShopName TEXT, LastPrice REAL, Date INTEGER)"
		''query = "INSERT INTO List VALUES (25, 6, 0, '" & DateTime.Now & "')"
		''SQL1.ExecNonQuery(query)
	' with date : PutList = "INSERT INTO List VALUES ('" & stuffTEXT & "', '" & shopLabel1.Text & "', '" & priceTEXT & "', '" & DateTime.Now & "', '" & Bought & "', '" & Spare1 & "', '" & Spare2 & "', '" & Spare3 & "')"
	' with no date :
		PutList = "INSERT INTO List VALUES ('" & stuffTEXT & "', '" & shopLabel1.Text & "', '" & priceTEXT & "', '*', '" & Bought & "', '" & Spare1 & "', '" & Spare2 & "', '" & Spare3 & "')"
	Log ("PutList - > " & PutList)
'************************************************
	'REMEMBER TO TURN THIS BACK ON WHEN THE TICK AND X LABEL ISSUE IS RESOLVED
	'
	' BeginTransaction
	'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''	SQL2.BeginTransaction
''	Try
		'''block of statements like:
		'''For i = 1 To 1000
		'''	SQL1.ExecNonQuery("INSERT INTO table1 VALUES(...)
		'''Next
''		SQL2.ExecNonQuery(PutList)
''		SQL2.TransactionSuccessful
''	Catch
''		Log(LastException.Message) 'no changes will be made
''	End Try
''	SQL2.EndTransaction
	'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'EndTransaction
	'************************************************
End Sub

Sub add2listlblAction2_Click

	''''' actually this isn't clickable because once the label add2listlblAction1 has been clicked
	''''' this is an indicator that an item has been extracted to a secondary list
	''''' so its actually NOT enabled and initially is NOT visible either
	
	'''''' but -> just in case we end up here :)
	add2listlblAction1.Visible = False
	add2listlblAction2.Visible = True
	
End Sub

Sub todayACColoredButton1_Click
	'
	ToastMessageShow ("Selected	 : Current Shopping List",False)
	
		'''	query = "CREATE TABLE List (Number INTEGER, StuffID INTEGER, shopID INTEGER, Date INTEGER)"

End Sub

Sub exitListACButton1_Click
	Activity.Finish
	StartActivity ("Main")
End Sub
